/* BEGIN_COMMON_COPYRIGHT_HEADER
 * (c)LGPL2+
 *
 * Nde - a lightweight, Qt based, desktop toolset
 * https://lxqt.org
 *
 * Copyright: 2010-2012 Razor team
 * Authors:
 *   Alexander Sokoloff <sokoloff.a@gmail.com>
 *
 * This program or library is free software; you can redistribute it
 * and/or modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA
 *
 * END_COMMON_COPYRIGHT_HEADER */


#include "popupmenu.h"
#include <QWidgetAction>
#include <KWindowEffects>
PopupMenu::PopupMenu(QWidget *parent):QMenu(parent), mBackgroundColor(QColor("black")),mOpacity(0.2)
{

    initBackgroundBlur();
}
PopupMenu::PopupMenu(QColor backgroundColor, qreal opacity, QWidget *parent):QMenu(parent)
    ,mBackgroundColor(backgroundColor)
    ,mOpacity(opacity)
{
    initBackgroundBlur();
}
void PopupMenu::initBackgroundBlur()
{
    setObjectName("PopupMenu");
//    QPalette pal = this->palette();
//    QColor windowColor = pal.color(QPalette::WindowText);
//    windowColor.setAlpha(60);
//    pal.setColor(QPalette::Window, windowColor);
//    this->setPalette(pal);
//    mBackgroundColor = QColor("black");
//    mOpacity = 0.2;
//    QString color = QString("%1, %2, %3, %4")
//        .arg(mBackgroundColor.red())
//        .arg(mBackgroundColor.green())
//        .arg(mBackgroundColor.blue())
//        .arg((float) mOpacity / 100);
//    QString sheet = QString("NdePanel #PopupMenu { background-color: rgba(" + color + "); }");
//    setStyleSheet(sheet);
    setAttribute(Qt::WA_TranslucentBackground);
    setAttribute(Qt::WA_NoSystemBackground, false);
//    Nde::setEnableBlurWindow(static_cast<uint32_t>(this->winId()) , true);
    KWindowEffects::enableBlurBehind(winId(), true);

    QString color = QString("%1, %2, %3, %4")
            .arg(mBackgroundColor.red())
            .arg(mBackgroundColor.green())
            .arg(mBackgroundColor.blue())
            .arg(mOpacity / 100.0);
    QString sheet = QString("NdePanel #PopupMenu { background-color: rgba(" + color + "); }");
    setStyleSheet(sheet);
}
