#ifndef DISPLAYMAINMENUFULL_H
#define DISPLAYMAINMENUFULL_H

#include <QWidget>
#include <QDomElement>
#include "mainmenuapplicationitemfull.h"
#include "mainmenucategoryitemfull.h"
#include "common.h"

namespace Ui {
class DisplayMainMenuFull;
}

class DisplayMainMenuFull : public QWidget
{
    Q_OBJECT

public:
    explicit DisplayMainMenuFull(QWidget *parent = nullptr);
    ~DisplayMainMenuFull();

    void restoreUI();

//    void setGradientColor(QColor color);

    //检测Lineedit 上下键 event
    virtual bool eventFilter(QObject *watched, QEvent *event);

Q_SIGNALS:
    void signalAddToDesktop(XdgDesktopFile desktopFile);
    void signalAddToQuickLaunch(XdgDesktopFile desktopFile);

private Q_SLOTS:
    void onMenuChanged();
    void onCommonAppChanged();
    void onSearchTextChanged(const QString & filter);
    void onLineeditReturnPressed();
    void onMenuCategoryChanged();
    void onCategoryBtnClicked();

private:
    void addToLayout();
    void clearLayout();
    //根据每个分类的子项目创建子layout
    QList<QHBoxLayout*> calItemLayout(QList<MainMenuApplicationItemFull*> list);
    //获取当前序列的item
    QList<MainMenuApplicationItemFull*> getCurSortItems();
    void focusFirstItem();
    void focusLastItem();
    void focusNextItem();
    void focusNextItemLine();
    void focusPrivItem();
    void focusPrivItemLine();

private:
    Ui::DisplayMainMenuFull *ui;

    QVBoxLayout * mMenuLayout;          //应用列表布局
    QVBoxLayout * mCategoryBtnsLayout;  //快速搜索按钮的布局
    MainMenuCategoryItemFull *mCommonCategory;//常用分类UI
    QHash<QString, MainMenuCategoryItemFull*> mAllCategories; //所有分类UI项

    bool mInputMethodActive; //输入法是否激活的状态
    //渐变阴影
//    QColor mGradColor;
//    GradientLabel * mTopGradLabel;
//    GradientLabel * mBottomGradLabel;
};

#endif // DISPLAYMAINMENUFULL_H
