#ifndef POWERMENU_H
#define POWERMENU_H

#include <QVBoxLayout>
#include <QPropertyAnimation>
#include <QProcess>
#include "toolbutton.h"

class PowerMenu : public QWidget
{
    Q_OBJECT
public:
    explicit PowerMenu(QWidget *parent = nullptr);

    void expend(bool extend);

    QList<ToolButton*> getBtns();

signals:
    void signalAnimFinished();
private slots:
    void onAnimFinished();
    void onComputerSleep();
    void onComputerSwitch();
    void onComputerLogout();
    void onComputerReboot();
    void onComputerPowerOff();

private:
    bool checkVirtualMachine();//判断虚拟机
    bool checkZteVersion(); //判断是否是zte定制版本

private:
    bool mExtend;
    QVBoxLayout * mLayout;
    QList<ToolButton*> mBtnList;
    QHash<ToolButton*, QPropertyAnimation*> mBtns;
};

#endif // POWERMENU_H
