#ifndef NOTIFYGROUPTITLE_H
#define NOTIFYGROUPTITLE_H

#include <QWidget>

namespace Ui {
class NotifyGroupTitle;
}

class NotifyGroupTitle : public QWidget
{
    Q_OBJECT

public:
    explicit NotifyGroupTitle(int width, uint id, QString name,
                              const QString &summary,
                              const QString &body,
                              const QString &icon,
                              const QStringList actions,
                              const QVariantMap &hints,
                              QWidget *parent = nullptr);
    ~NotifyGroupTitle();

    void setNotifyCount(int count);

signals:
    void signalGroupClose();
    void signalGroupExtend(bool extend);

protected:
    virtual void paintEvent(QPaintEvent *event);
    virtual void mousePressEvent(QMouseEvent *event);
    virtual void mouseReleaseEvent(QMouseEvent *event);
    virtual void enterEvent(QEvent *event);
    virtual void leaveEvent(QEvent *event);

private:

private:
    QPixmap getPixmapFromHint(const QVariant &argument) const;
    QPixmap getPixmapFromString(const QString &str) const;
private:
    Ui::NotifyGroupTitle *ui;
    uint m_appID;
    QString m_appName;
    QPixmap m_pixmap; //tubiaowenjian
    bool m_extend;
};

#endif // NOTIFYGROUPTITLE_H

