#ifndef STATUSNOTIFIERTRAY_H
#define STATUSNOTIFIERTRAY_H

#include <QWidget>
#include "../panel/indepanelplugin.h"
#include "statusnotifierwidget.h"

class StatusNotifierPopup;
class StatusNotifierWatcher;
class PluginSettings;
class SniAsync;
class StatusNotifierArrow : public QToolButton
{
    Q_OBJECT
    Q_PROPERTY(Qt::Corner origin READ origin WRITE setOrigin)

public:
    Qt::Corner origin() const;
    void setOrigin(Qt::Corner);
    explicit StatusNotifierArrow(QWidget *parent = nullptr);
    static QString mimeDataFormat() { return QLatin1String("nde/StatusNotifierButton"); }
signals:
    void dropArrow(QString & serviceAndPath);
protected:
    void dropEvent(QDropEvent * event);
    void dragEnterEvent(QDragEnterEvent * event);
    void paintEvent(QPaintEvent * event);
private:
    Qt::Corner mOrigin;
    QPixmap mPixmap;
    bool mDrawPixmap;
};

class StatusNotifierTray : public StatusNotifierWidget
{
    Q_OBJECT
public:
    explicit StatusNotifierTray(INdePanelPlugin *plugin, QWidget *parent = nullptr);
    virtual ~StatusNotifierTray();
    void realign();
public slots:
    void recalculatePopupPosition();
protected:
    void leaveEvent(QEvent *event);
private:
    void hideArrow();
    void ItemUnregistered(const QString & serviceAndPath);
    StatusNotifierPopup *mPopup;
    StatusNotifierWatcher *mWatcher;
    StatusNotifierArrow *mArrow;
    PluginSettings *mSettings;
    INdePanel::Position mCurPanelPos;
    QRect mScreenRect;
    QTimer *mWatchCursor;
};

#endif // STATUSNOTIFIERTRAY_H
